// OG_constreambuf.cpp: Implementierung der Klasse OG_constreambuf.
//
// Autor: Olaf Groeger
// EMail: Olaf.Groeger@gmx.de
//
// Status: Macht damit, was ihr wollt
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OG_constream.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

using std::ostream;

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

/*
OG_constreambuf::OG_constreambuf()
{
	pReserve = new char[100];
	setp(pReserve, pReserve + 100);

	setg(0, 0, 0);		// Version 1

	CreateConsole();
}
*/

OG_constreambuf::~OG_constreambuf()
{
	sync();

	if (pReserve)
		delete pReserve;
	DeleteConsole();
}

OG_constreambuf::OG_constreambuf(int iBuffersize)
{
	if (iBuffersize)
	{
		pReserve = new char[iBuffersize];
		setp(pReserve, pReserve + iBuffersize);
	}
	else
	{
		pReserve = NULL;
		setp(0, 0);
	}

	setg(0, 0, 0);		// Version 1

	CreateConsole();
}

void OG_constreambuf::CreateConsole()
{
	if (!AllocConsole())
	{
		FreeConsole();
		AllocConsole();
	}
	hConsoleOut = GetStdHandle(STD_OUTPUT_HANDLE);
}

void OG_constreambuf::DeleteConsole()
{
	CloseHandle(hConsoleOut);

	FreeConsole();
}

int OG_constreambuf::sync()
{
	WriteToConsole();
	return(0);
}

void OG_constreambuf::WriteToConsole()
{
	DWORD dwCharsToWrite = pptr() - pbase();
	DWORD dwCharsWritten;
	
	if (dwCharsToWrite)
	{
		WriteConsole(hConsoleOut, pReserve, dwCharsToWrite, &dwCharsWritten, NULL);
	
		setp(pbase(), epptr());
	}
}

int OG_constreambuf::overflow(int c)
{
	WriteToConsole();

	
	if (c != EOF)
            if (pbase() == epptr())
              WriteCharToConsole(c);
            else
              sputc(c);
        
      return 0;
        
}

void OG_constreambuf::WriteCharToConsole(int c)
{

	DWORD dwCharsWritten;
	int c1 = c;
	WriteConsole(hConsoleOut, &c1, 1, &dwCharsWritten, NULL);
}

OG_constream::OG_constream() : ostream(new OG_constreambuf())
{

}

OG_constream::OG_constream(int i) : ostream(new OG_constreambuf(i))
{

}

OG_constream::~OG_constream()
{
	OG_constreambuf* pOG_constreambuf = (OG_constreambuf*) rdbuf();
	if (pOG_constreambuf)
		delete pOG_constreambuf;
}
